{=======================================================================}
{ SESSIONS      Display the results of a Session Status NetBIOS call	}
{									}
{ Issue the NetBIOS Session Status command, and print the values of the	}
{ various fields.  The status of all sessions at the local adapter will	}
{ be displayed.								}
{=======================================================================}

program sessions;

uses dos, crt, netbios;

var
    StatNcb	: Ncb;
    DatBuffer	: SessionStatus;
    ErrCode	: byte;

function IssueStat : byte;
var
    I   : Word;
    Len : Word;
    Arg : String;
begin
    ClearNcb(StatNcb);
    with StatNcb do begin
	Buffer     := @DatBuffer;
	Length     := SizeOf(DatBuffer);
	if ParamCount > 0 then
	    Arg := ParamStr(1)
	else
	    Arg := '*';
	Len := System.Length(Arg);
	if Len > 16 then
	    Len := 16;
	for I := 1 to Len do
	    LocName[I] := Arg[I];
	for I := Len+1 to 16 do
	    LocName[I] := ' ';
	Command    := NBSessionStatus;
    end;
    CallNetBIOS(StatNCB);
    IssueStat := StatNCB.RetCode;
end;

procedure DumpStatRec(Length : word);
var
    I : word;
begin
    with DatBuffer do begin
	write('NameNum=', NameNum,'  SCount=', SCount);
	writeln('  DGPend=', DGPend, '  RAPend=', RAPend);
	for I := 1 to ((Length-4) div 36) do with TableEntry[i] do begin
	    write(I:2,':     LSN=',LSN);
	    write('  RPend=',RPend,'  SPend=',SPend);
	    write('  State=', State, ' (');
	    case State of
		1 :  writeln('Listen Pending)');
		2 :  writeln('Call Pending)');
		3 :  writeln('Session Established)');
		4 :  writeln('Hang Up Pending)');
		5 :  writeln('Hang Up Complete)');
		6 :  writeln('Session Aborted)');
		else writeln('unknown)');
	    end;
            writeln('        LocName="',LocName,'"  RemName="',RemName,'"');
	end;
    end;
end;

begin
    ErrCode := IssueStat;
    if ErrCode <> 0 then
	writeln('Request status error ',ErrCode)
    else begin
	writeln('Returned Size = ',StatNcb.Length);
	DumpStatRec(StatNcb.Length);
    end;
end.
